## Fixes

- Fixed backtest stop limit order / stop market order emulation.
- Fixed optimizer panic issue (when report is nil)
- Fixed pnl command market settings.
- Fixed MAX API endpoints.

## Improvements

- Improved supertrend strategy.
- Improved pivotshort strategy.
- Refactor reward service sync.

## Features

- Added tearsheet backend api
- Added seriesExtend for indicators.
- Added progressbar to optimizer.

## New API

- Added ExitMethodSet (trailing stop, roi stop loss, roi take profit, ... etc)
- Added new graceful shutdown API, persistence API, notification API, order executor API.

[Full Changelog](https://github.com/c9s/bbgo/compare/v1.35.0...main)

 - [#799](https://github.com/c9s/bbgo/pull/799): Improve supertrend strategy
 - [#801](https://github.com/c9s/bbgo/pull/801): feature: optimizer: support --tsv option and render tsv output
 - [#800](https://github.com/c9s/bbgo/pull/800): fix: fix exit method for trailing stop
 - [#798](https://github.com/c9s/bbgo/pull/798): fix: fix trailingstop and add long position test case
 - [#797](https://github.com/c9s/bbgo/pull/797): feature: re-implement trailing stop and add mock test
 - [#796](https://github.com/c9s/bbgo/pull/796): strategy/pivotshort: add supportTakeProfit method
 - [#793](https://github.com/c9s/bbgo/pull/793): Fix pnl command
 - [#795](https://github.com/c9s/bbgo/pull/795): optimizer/fix: prevent from crashing if missing SummaryReport
 - [#794](https://github.com/c9s/bbgo/pull/794): strategy/pivotshort: fix resistance updater
 - [#792](https://github.com/c9s/bbgo/pull/792): strategy/pivotshort: fix findNextResistancePriceAndPlaceOrders
 - [#791](https://github.com/c9s/bbgo/pull/791): strategy: pivotshort: refactor breaklow logics
 - [#790](https://github.com/c9s/bbgo/pull/790): fix: strategy: pivoshort: cancel order when shutdown
 - [#789](https://github.com/c9s/bbgo/pull/789): strategy: pivotshort: add more improvements for margin
 - [#787](https://github.com/c9s/bbgo/pull/787): strategy: pivotshort: use active orderbook to maintain the resistance orders
 - [#786](https://github.com/c9s/bbgo/pull/786): strategy: pivotshort: resistance short
 - [#731](https://github.com/c9s/bbgo/pull/731): add tearsheet backend api (Sharpe)
 - [#784](https://github.com/c9s/bbgo/pull/784): strategy: pivotshort: fix stopEMA
 - [#785](https://github.com/c9s/bbgo/pull/785): optimizer: add progressbar
 - [#778](https://github.com/c9s/bbgo/pull/778): feature: add seriesExtend
 - [#783](https://github.com/c9s/bbgo/pull/783): fix: pivotshort: fix kline history loading
 - [#782](https://github.com/c9s/bbgo/pull/782): refactor: moving exit methods from pivotshort to the core
 - [#781](https://github.com/c9s/bbgo/pull/781): strategy: pivotshort: optimize and update config
 - [#775](https://github.com/c9s/bbgo/pull/775): test: backtest: add order cancel test case
 - [#773](https://github.com/c9s/bbgo/pull/773): fix: fix backtest taker order execution
 - [#772](https://github.com/c9s/bbgo/pull/772): fix: backtest: fix stop order backtest, add more test cases and assertions
 - [#770](https://github.com/c9s/bbgo/pull/770): fix: fix backtest stop limit order matching and add test cases
 - [#769](https://github.com/c9s/bbgo/pull/769): backtest-report: sort intervals
 - [#768](https://github.com/c9s/bbgo/pull/768): feature: backtest: add ohlc legend
 - [#766](https://github.com/c9s/bbgo/pull/766): backtest-report: add time range slider
 - [#765](https://github.com/c9s/bbgo/pull/765): improve: backtest-report layout improvements, EMA indicators and fixed the clean up issue
 - [#764](https://github.com/c9s/bbgo/pull/764): strategy/pivotshort: refactor exit methods and add protection stop exit method
 - [#761](https://github.com/c9s/bbgo/pull/761): datasource: refactor glassnodeapi
 - [#760](https://github.com/c9s/bbgo/pull/760): doc: fix link
 - [#758](https://github.com/c9s/bbgo/pull/758): improve: add pnl cmd options and fix trade query
 - [#757](https://github.com/c9s/bbgo/pull/757): totp-user: add default user 'bbgo'
 - [#756](https://github.com/c9s/bbgo/pull/756): refactor: clean up rsmaker, xbalance, dca, pivotshort strategies
 - [#755](https://github.com/c9s/bbgo/pull/755): improve: bbgo: call global persistence facade to sync data
 - [#754](https://github.com/c9s/bbgo/pull/754): optimizer: refactor max num of process in optimizer configs
 - [#750](https://github.com/c9s/bbgo/pull/750): refactor: persistence singleton and improve backtest cancel performance
 - [#753](https://github.com/c9s/bbgo/pull/753): optimizer: add max num of thread in config
 - [#752](https://github.com/c9s/bbgo/pull/752): Upgrade nextjs from 11 to 12
 - [#751](https://github.com/c9s/bbgo/pull/751): fix: reformat go code
 - [#746](https://github.com/c9s/bbgo/pull/746): pivotshort: add strategy controller
 - [#747](https://github.com/c9s/bbgo/pull/747): strategy/supertrend: use new order executor api
 - [#748](https://github.com/c9s/bbgo/pull/748): bollmaker: remove redundant code for adapting new order executor api
 - [#749](https://github.com/c9s/bbgo/pull/749): improve: add parallel local process executor for optimizer
 - [#639](https://github.com/c9s/bbgo/pull/639): strategy: rsmaker: initial idea prototype
 - [#745](https://github.com/c9s/bbgo/pull/745): fix: depth: do not test depth buffer when race is on
 - [#744](https://github.com/c9s/bbgo/pull/744): refactor: refactor and update the support strategy
 - [#743](https://github.com/c9s/bbgo/pull/743): strategy/bollmaker: refactor and clean up
 - [#742](https://github.com/c9s/bbgo/pull/742): refactor: clean up bbgo.Notifiability
 - [#739](https://github.com/c9s/bbgo/pull/739): refactor: redesign order executor api
 - [#738](https://github.com/c9s/bbgo/pull/738): feature: binance: add binance spot rebate history support
 - [#736](https://github.com/c9s/bbgo/pull/736): fix: gosimple alert
 - [#737](https://github.com/c9s/bbgo/pull/737): refactor: refactor reward service sync
 - [#732](https://github.com/c9s/bbgo/pull/732): Refactor grid panel
 - [#734](https://github.com/c9s/bbgo/pull/734): fix: apply gofmt on all files, add revive action
